"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamicCallFn = exports.BasicdemoHook = void 0;
const react_1 = __importDefault(require("react"));
const use_async_request_1 = require("./use-async-request");
const sleep = (delay) => new Promise((res) => {
    setTimeout(function () {
        res();
    }, delay);
});
const callFn = () => __awaiter(void 0, void 0, void 0, function* () {
    yield sleep(100);
    alert('hello');
    return { message: 'world' };
});
const BasicdemoHook = () => {
    const { loading, response, error, reload } = (0, use_async_request_1.useAsyncRequest)({
        args: [],
        callOnInit: false,
        callFn,
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("h1", null, "Output "),
        loading ? 'Loading' : 'Not loading',
        react_1.default.createElement("button", { onClick: () => reload() }, "Call"),
        react_1.default.createElement("p", null, response === null || response === void 0 ? void 0 : response.message)));
};
exports.BasicdemoHook = BasicdemoHook;
const DynamicCallFn = () => {
    const callFnA = () => __awaiter(void 0, void 0, void 0, function* () {
        yield sleep(100);
        alert('hello');
        return { message: 'world' };
    });
    const { loading, response, error, reload } = (0, use_async_request_1.useAsyncRequest)({
        args: [],
        callOnInit: false,
        callFn: callFnA,
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("h1", null, "Output "),
        loading ? 'Loading' : 'Not loading',
        react_1.default.createElement("button", { onClick: () => reload() }, "Call"),
        react_1.default.createElement("p", null, response === null || response === void 0 ? void 0 : response.message)));
};
exports.DynamicCallFn = DynamicCallFn;
//# sourceMappingURL=use-async-request.composition.js.map